﻿namespace UltraGridRowsWipesOut
{
    using System;
    using System.Data;
    using System.Windows.Forms;
    using Infragistics.Win;
    using Infragistics.Win.UltraWinGrid;

    public partial class Form1 : Form
    {

        public Form1()
        {
            this.InitializeComponent();
            this.Load += Form1_Load;
            this.UltraGridList.BeforeCellActivate += UltraGridList_BeforeCellActivate;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            var data = this.GetData();
            this.UltraGridList.SetDataBinding(data, data.TableName);
        }


        private void UltraGridList_BeforeCellActivate(object sender, CancelableCellEventArgs e)
        {
            if(e.Cell.Column.Key == "Column #1")
            {
                ValueList valLstPackage = new ValueList();
                valLstPackage.ValueListItems.Add("1 " + e.Cell.Row.Cells[1].Value.ToString());
                valLstPackage.ValueListItems.Add("2 " + e.Cell.Row.Cells[1].Value.ToString());
                valLstPackage.ValueListItems.Add("3 " + e.Cell.Row.Cells[1].Value.ToString());
                valLstPackage.ValueListItems.Add("4 " + e.Cell.Row.Cells[1].Value.ToString());
                this.UltraGridList.DisplayLayout.Bands[0].Columns["Column #1"].ValueList = valLstPackage;
            }
        }

        private DataTable GetData(int rows = 20, int cols = 5)
        {
            DataTable dt = new DataTable();

            for(int col = 0; col < cols; col++)
            {
                dt.Columns.Add(string.Format("Column #{0}", col + 1));
            }

            for(int row = 0; row < rows; row++)
            {
                DataRow addRow = dt.NewRow();
                foreach(DataColumn column in dt.Columns)
                {
                    addRow[column] = string.Format("{0}.{1}", row + 1, column.Ordinal + 1);
                }

                dt.Rows.Add(addRow);
            }

            return dt;
        }
    }
}
